-- RemoteControl ver. 0.1.5a
-- skrypt Lua dla wtyczki Konnekt Bot
---------------------------------------------------

---------------------------------------------------
-- Spis Komend
--
-- Napisz /rc help, aby otrzymac wicej informacji
---------------------------------------------------

---------------------------------------------------
--		CHANGELOG
--
--ver. 0.1.5a
--	- wszystkie komuniakty w tablicy, aby atwo
--	  mona byo zmienic ich tre
--	- dodana zostaa opcja logowania si przed
--	  wydaniem komendy z zewnatrz
--	- poprawione przekierowywanie wiadomoci
--	- dodana nowa komenda 'getoptions'
--
--ver. 0.1a
--	- pierwszy public release
---------------------------------------------------

---------------------------------------------------
--			TODO
--
-- * Powiadamianie smsem o pierwszej wiadomosci od
--   kontaktu (do przemylenia)
-- * Logowanie wszystkich wydawanych komend do pliku
---------------------------------------------------

---------------------------------------------------
-- zmienne o zasiegu skryptu
-- zapominane po wylaczeniu skryptu
---------------------------------------------------

recv_contacts = {}
lang = {}
help = {}
options = {}
RcvCntID = 0
version = "0.1.5a"
start = 0

---------------------------------------------------
-- tablice do obslugi wiadomosci
---------------------------------------------------

lang["load"] = "Skrypt uruchomiony"
lang["notify_load"] = "<b>RemoteControl<b> zosta uruchomiony"
lang["unload"] = "Skrypt wyczony"
lang["RC_start"] = "#RC: RemoteControl zosta wczony"
lang["RC_stop"] = "#RC: RemoteControl zosta wyczony"
lang["msg_variables"] = "Zmienne:"
lang["msg_send"] = "Wysae wiadomo do "
lang["msg_ofBody"] = "o treci:\n"
lang["msg_noBody"] = "Nie podae treci wiadomoci"
lang["msg_sent_contact"] = "Kontakt "
lang["msg_sent"] = "wysa wiadomo:"
lang["stat_set"] = "Status zosta ustawiony na"
lang["stat_set_descr"] = "Status opisowy zosta zmieniony na"
lang["error_auth"] = "Bd autoryzacji! Zaloguj si!"
lang["error_noParams"] = "Podae zy parametr lub wogle go nie podae"
lang["error_status"] = "Niepowodzenie zmiany statusu"
lang["error_notrun"] = "Skrypt nie jest wczony"

help[1] = "#RC: #####################################"
help[2] = "#RC: RemoteControl v."..version
help[3] = "#RC: made by Winthux [wTx]"
help[4] = "#RC:"
help[5] = "#RC: Spis komend lokalnych:"
help[6] = "#RC: /rc start - uruchamia skrypt, aby moc odbierac msgs"
help[7] = "#RC: /rc stop - zatrzymuje skrypt"
help[8] = "#RC: /rc help - wywietla ten help"
help[9] = "#RC:"
help[10] = "#RC: Spis komend zdalnych:"
help[11] = "#RC: >rc send [nick] [message] - wysya [nick] wiadomo"
help[12] = "#RC:		o treci [message]"
help[13] = "#RC: >rc adminID - ustawia ID usera, gdzie bd kierowane"
help[14] = "#RC:		wszystkie przychodzce wiadomoci"
help[15] = "#RC: >rc contacts - wywietla wszystkie kontakty online i away"
help[16] = "#RC: >rc getstatus - pobiera status"
help[17] = "#RC: >rc setstatus [status] [opis] - ustawia [status] z opisem [opis]"
help[18] = "#RC: >rc getoptions - pobiera wszystkie zmienne uzywane przez skrypt"
help[19] = "#RC:		wraz z wartociami"
help[20] = "#RC:"
help[21] = "#RC: Wszdzie gdzie s nawiasy kwadratowe trzeba co wpisa ;)"
help[22] = "#RC: #####################################"

options[1] = "RC_AdminId"
options[2] = "pass"

---------------------------------------------------
-- event - start Bot
---------------------------------------------------
function IInit ()
  KLogSet("RemoteControl by wTx", "rmtctrl.log")
  KLog(lang["load"])
  KNotify(lang["notify_load"])

  return 0,2 -- wymagana wersja KBota
end


---------------------------------------------------
-- event - stop Bot
---------------------------------------------------
function IDeInit ()
  KLog(lang["unload"])
end


---------------------------------------------------
-- event - command
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommand (cntID, command, params)

  if command == "rc" then
	local var = params[1]

	if var == "start" then
		start = 1
		KInform(cntID, lang["RC_start"])
		return true
  	elseif var == "stop" then
		start = 0
		KInform(cntID, lang["RC_stop"])
		return true
	elseif var == "help" then
		for idx, idz in help do
			KInform(cntID, help[idx])
		end
	elseif var ~= nil or params[1] == nil then
		KInform(cntID,lang["error_noParams"])
		return true
	end
  end
  return false
end


---------------------------------------------------
-- event - commandrcv
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommandRcv (cntID, command, params)

if start == 1 then
  if command == "rc" then
	local var = params[1]
	local logged = KCfgCntGet(cntID, "logged")
	if var == "send" then
		local val = params[2]
		if logged~="undefined" and logged=="yes" then
			if val ~= nil  then
				local nameID = KCntFindID(val)
				local body=""
				local len
				len = string.len(val)
				for idx, param in params do
      					body = body.." "..param
				end
				body = string.sub(body,len+8)
				KSend(nameID, body)
				KSend(cntID, "<RC><text>#RC: "..lang["msg_send"]..val.."["..KCntGetUID(nameID).."] "..lang["msg_ofBody"]..body)
			else
				KSend(cntID, "<RC><error>#RC: "..lang["msg_noBody"])
			end
		else
			KSend(cntID, "<RC><error>#RC: "..lang["error_auth"])
		end
		return true
	
	elseif var == "uid" then
		if logged~="undefined" and logged=="yes" then
			KCfgSet("RC_AdminId", cntID)
			KSend(cntID, "<RC><text>#RC: AdminID = "..cntID)
		else
			KSend(cntID, "<RC><error>#RC: "..lang["error_auth"])
		end
		return true	
	elseif var == "contacts" then
		if logged ~= "undefined" and logged == "yes" then
			local contacts_online = {}
			local contacts_away = {}
			KCntList(-1, contacts_online, ST.online)
			KCntList(-1, contacts_away, ST.away)
			for var, val in contacts_online do
				KSend(cntID, "<RC><online>"..KCntInfo(contacts_online[var], "display").." ["..KCntGetUID(contacts_online[var]).."]")
			end
			--for var, val in contacts_away do
				--KSend(cntID, "<RC><away>"..KCntInfo(contacts_away[var], "display").." ["..KCntGetUID(contacts_away[var]).."]")
			--end
			KSend(cntID, "</RC>")
		else
			KSend(cntID, "<RC><error>#RC: "..lang["error_auth"])
		end
    		return true
	elseif var == "getstatus" then
		if logged ~= "undefined" and logged == "yes" then
			KSend(cntID, "<RC><status>#RC: Status: "..KStatusName(KStatusGet(KCntInfo(cntID, "net"))))
		else
			KSend(cntID, "<RC><error>#RC: "..lang["error_auth"])
		end
		return true
	elseif var == "setstatus" then
		if logged~="undefined" and logged=="yes" then
	    		local status, opis = "", ""
    			status = params[2]
    			opis = params[3]
	    		if opis == nil then
      				opis = ""
    			end
    			if status ~= nil then
      				local statusID = -1 -- pozostawia stary status
      				statusID = KStatusNum(status) -- zamienia status opisowy na liczbe lub -1 gdy nieznany
      				if KStatusSet(KCntInfo(cntID, "net"), statusID, opis) then
        				KSend(cntID, "<RC><error>#RC: "..lang["error_status"])
      				else
        				if status ~= "old" then
          					KSend(cntID, "<RC><status>#RC: "..lang["stat_set"]..status.." \""..opis.."\"")
        				else
          					KSend(cntID, "<RC><status>#RC: "..lang["stat_set_descr"].." \""..opis.."\"")
       					end
      				end
    			else
      				KSend(cntID, "<RC><error>#RC: "..lang["error_noParams"])
    			end
		else
			KSend(cntID, "<RC><error>#RC: "..lang["error_auth"])
		end
    		return true
	elseif var == "getoptions" then
		if logged ~= "undefined" and logged == "yes" then
			local variable
			KSend(cntID, lang["msg_variables"]);
			for idx,idz in options do
				variable = KCfgGet(options[idx])
				if variable == "undefined" then
					variable = KCfgCntGet(cntID, options[idx])
				end
				KSend(cntID, "<RC><text>#RC: "..options[idx].." = "..variable)
			end
		else
			KSend(cntID, "<RC><status>#RC: "..lang["error_auth"])
		end
	end
  end
else
  KSend(cntID, "<RC><error>#RC: "..lang["error_notrun"])
end

  return false
end



---------------------------------------------------
-- event - receive
---------------------------------------------------
-- argumenty: msg to obiekt
---------------------------------------------------
function IRecv (msg)
	local body = msg.GetBody()
	local cntID = msg.GetCnt()
	local admID = KCfgGet("RC_AdminId")

	if start == 1 and admID ~= "undefined" then  
  		local message = "#RC: "..lang["msg_sent_contact"]..KCntInfo(cntID, "display").." ["..KCntGetUID(cntID).."] "..lang["msg_sent"].."\n"..body
  		KSend(tonumber(admID), message)
	end

	if preg_match("#\<RC\>#",body) ~= 0 then
		if preg_match("#\<online\>#", body) ~= 0 then
			recv_contacts[RcvCntID] = preg_replace("#\<online\>#", "", preg_replace("#\<RC\>#","",body))
			RcvCntID = RcvCntID +1
			msg.SetBody("")
		--elseif preg_match("#\<away\>#", body) ~= 0 then
			--recv_contacts[RcvCntID] = preg_replace("#\<away\>#", "", preg_replace("#\<RC\>#","",body))
			--RcvCntID = RcvCntID +1
			--msg.SetBody("")
		elseif preg_match("#\<status\>#", body) ~= 0 then
			KInform(cntID, preg_replace("#\<RC\>#", "", preg_replace("#\<status\>#", "", body)))
			msg.SetBody("")
		elseif preg_match("#\<error\>#", body) ~= 0 then
			KInform(cntID, preg_replace("#\<RC\>#", "", preg_replace("#\<error\>#", "", body)))
			msg.SetBody("")
		elseif preg_match("#\<text\>#", body) ~= 0 then
			KInform(cntID, preg_replace("#\<RC\>#", "", preg_replace("#\<text\>#", "", body)))
			msg.SetBody("")
		end
	end

	if preg_match("#\<\/RC\>#", body) ~= 0 then
		
		recv_contacts[RcvCntID] = preg_replace("#\<\/RC\>#","",body)
		RcvCntID = 0
		table.sort(recv_contacts)
		for var, val in recv_contacts do
			KInform(cntID,recv_contacts[var])
		end
		msg.SetBody("")
	end
end